library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity ricerca is
port (rst,clk,nw: in std_logic;
      val: in std_logic_vector(3 downto 0);
      risultato: out std_logic_vector(2 downto 0);
      trovato, fine: out std_logic );
 end ricerca;
 
 architecture beh of ricerca is
 type stati is (idle,leggi,ricerca,aggiorna);
 signal cs: stati;
 type memo is array (0 to 7) of std_logic_vector(3 downto 0);
 signal mem: memo := 
     ("0000","0001","1010","0111","1100","0101","1111","1001");
 signal tmp: std_logic_vector(2 downto 0);
 signal mem_en, ric_en,aggiorna_en,ttrovato,clk_mem: std_logic;
 signal X: std_logic_vector(3 downto 0);
 signal azzera : std_logic;
 begin
 
  process(rst,clk)
  begin
    if rst = '1' then cs <= idle;
    			
    elsif clk'event and clk='0' then
      case cs is
       when idle =>  if nw='0' then cs <= idle;
                     else cs <= leggi;
                          
                     end if;
       when leggi => cs <= ricerca;
       when ricerca => cs <= aggiorna;
       when others => cs <= idle;
      end case;
    end if;
  end process;
  
  process(cs)
  begin
   case cs is
     when idle  =>  mem_en<= '0';
     		    ric_en<='0';
     		    aggiorna_en<='0';
     when leggi =>  mem_en<= '1';
     		    ric_en<='0';
     		    aggiorna_en<='0';
     when ricerca => mem_en<= '0';
     		     ric_en<='1';
     		     aggiorna_en<='0';
     when aggiorna => mem_en<= '0';
     		      ric_en<='0';
     		      aggiorna_en<='1';
     end case;
  end process;
  
  clk_mem <= clk and mem_en;
  
  process(clk_mem)
   begin
     if clk_mem'event and clk_mem='0' 
          then 
            X<= val;
     end if;
   end process;
   
  process(clk)
    variable trovato: std_logic;
    variable p: integer;
    begin
     if clk'event and clk='0' then 
      p:=0;
      trovato:='0';
      if ric_en = '1' then
         
         for i in 0 to 7 loop
            if mem(i) = X then 
              trovato:= '1';
              p:= i;
              
            end if;
         end loop;
      end if; 
       
      ttrovato<= trovato;
      tmp<= conv_std_logic_vector(p,3);  
     end if;    
      
    end process;
    
    
    process(clk,rst)
    begin
    if rst='1' then risultato <= "000" ;
    		    trovato <= '0';
    		    fine <= '1';
    elsif clk'event and clk='0' then
           fine <= aggiorna_en;
           trovato <= ttrovato;
           if aggiorna_en = '1' then
            
            risultato <= tmp;
            
            end if;
    end if;
    end process;
    
    end beh;
    
      
                 
     



